import java.io.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;

/**
* INF 6450
* Daniel Lemire
*/
public class MonApplicationSAX extends DefaultHandler {



    /**
    * vnement correspondant au dbut d'un lment
    */
    public void startElement (String uri, String name, String qName, 
                                            Attributes atts)  {
       if(uri.length()>0)
	       System.out.println("Dbut de l'lment "+uri+":"+qName);
       else 
	       System.out.println("Dbut de l'lment "+name);
    }

    /**
    * vnement correspondant  la fin d'un lment
    */
    public void endElement (String uri, String name, String qName)   {
       if(uri.length()>0)
	       System.out.println("Fin de l'lment "+uri+":"+qName);
       else 
	       System.out.println("Fin de l'lment "+name);

    }
    
    /**
    * Ici on traite l'vnement correspondant  un noeud de texte
    */
    public void characters (char charac[], int debut, int longueur) {
      for (int i = debut; i < longueur+debut; ++i) 
	      System.out.print(charac[i]);
      System.out.println();
    }

    /**
    * on traite un fichier offert en ligne de commande.
    * Utilisation: java MonApplicationSAX nomdufichier.xml
    */
    public static void main (String args[]) throws Exception {
	XMLReader xr = XMLReaderFactory.createXMLReader();
	xr.setContentHandler(new MonApplicationSAX());
        xr.parse(new InputSource(new FileReader(args[0])));
    }

}
